package factory.clients;

import java.rmi.RemoteException;
import javax.ejb.*;
import javax.naming.*;
import javax.rmi.PortableRemoteObject;
import java.util.Properties;
import java.io.*;

import factory.manufacture.Manufacture;
import factory.manufacture.ManufactureHome;
import factory.manage_orders.OpenOrderView;

public class CompleteManufacture
{
  private static final String FILE_NAME = "c:/current_product.ser";
  private static final String CARRIER = "State Express";
  private static final int LOADING_DOCK = 1;

  public static void main(String[] args)
  {
    try
    {
      ContextPropertiesFactory factory = new ContextPropertiesFactory();
      factory.makePropertiesDefault();

      FileInputStream inStream = new FileInputStream(FILE_NAME);
      ObjectInputStream in = new ObjectInputStream(inStream);
      Handle handle = (Handle) in.readObject();
      Manufacture manufacture = (Manufacture)
                  PortableRemoteObject.narrow(handle.getEJBObject(), 
                                              Manufacture.class);
      System.out.println("Product routings:");

      while(manufacture.hasNextRouting())
      {
        String routing = manufacture.getNextRouting();
        System.out.println(routing);
      }
      System.out.println("Product finished; shipping...");
      manufacture.ship(CARRIER, LOADING_DOCK);
      manufacture.remove();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
    catch(Throwable t)
    {
      t.printStackTrace();
    }
  }
}
