package factory.clients;

import java.rmi.RemoteException;
import javax.ejb.*;
import javax.naming.*;
import javax.rmi.PortableRemoteObject;
import java.util.Properties;
import java.util.Calendar;
import java.util.Date;

import factory.manage_orders.ManageOrders;
import factory.manage_orders.ManageOrdersHome;

public class PlaceSampleOrders
{
  private static final int SALES_DIVISION_1 = 1;
  private static final int SALES_DIVISION_2 = 2;
  private static final int SALES_DIVISION_3 = 3;

  private static final int ORDER_1 = 1;
  private static final int ORDER_2 = 2;
  private static final int ORDER_3 = 3;
  private static final int ORDER_4 = 4;
  private static final int ORDER_5 = 5;

  private static final String PRODUCT_1 = "DESK01";
  private static final String PRODUCT_2 = "CHAIR01";
  private static final String PRODUCT_3 = "LAMP01";

  public static void main(String[] args)
  {
    try
    {
      ContextPropertiesFactory factory = new ContextPropertiesFactory();
      Properties prop = factory.getInitialContextProperties();
      InitialContext initial = new InitialContext(prop);
      //InitialContext initial = new InitialContext();

      Object homeObject = initial.lookup("ManageOrders");

      ManageOrdersHome home = (ManageOrdersHome)
        PortableRemoteObject.narrow(homeObject, ManageOrdersHome.class);

      ManageOrders manageOrders = home.create();

      Calendar calendarNotSchedulable = Calendar.getInstance();
      calendarNotSchedulable.add(Calendar.DAY_OF_YEAR, 14);

      Calendar calendarSchedulable = Calendar.getInstance();
      calendarSchedulable.add(Calendar.DAY_OF_YEAR, 5);

      Calendar calendarOverdue = Calendar.getInstance();

      manageOrders.placeOrder(SALES_DIVISION_1, ORDER_1, PRODUCT_1, 
                              calendarNotSchedulable.getTime());

      manageOrders.placeOrder(SALES_DIVISION_2, ORDER_1, PRODUCT_2, 
                              calendarNotSchedulable.getTime());

      manageOrders.placeOrder(SALES_DIVISION_1, ORDER_2, PRODUCT_3, 
                              calendarSchedulable.getTime());

      manageOrders.placeOrder(SALES_DIVISION_2, ORDER_2, PRODUCT_1, 
                              calendarSchedulable.getTime());

      manageOrders.placeOrder(SALES_DIVISION_1, ORDER_3, PRODUCT_2, 
                              calendarOverdue.getTime());

      manageOrders.placeOrder(SALES_DIVISION_2, ORDER_3, PRODUCT_3, 
                              calendarOverdue.getTime());

    }
    catch(Exception e)
    {
      e.printStackTrace();
    }

  }
}
