package book.order;

import javax.ejb.*;
import java.rmi.RemoteException;
import java.util.Date;
import book.product.Product;

public interface Order extends EJBObject
{
  public int getSalesDivision()
    throws RemoteException;

  public int getOrderNumber()
    throws RemoteException;

  public Product getProductOrdered()
    throws RemoteException;

  public String getStatus()
    throws RemoteException;

  public void cancelOrder()
    throws RemoteException, OrderNotCancelableException;

  public void beginManufacture()
    throws RemoteException;

  public void completeManufacture()
    throws RemoteException;

  public Date getDateDue()
    throws RemoteException;
}
