package book.product;

import javax.ejb.*;
import java.util.List;
import java.util.LinkedList;
import java.util.Arrays;
import java.util.Iterator;

public class ProductEJB implements EntityBean
{

  // properties

  public String product;
  public String name;
  public List routingInstructions;

  // business methods

  public String getProduct()
  {
    return product;
  }

  public String getName()
  {
    return name;
  }

  public void setName( String name )
  {
    this.name = name;
  }

  public RoutingInstruction[] getRoutingInstructions()
  {
    RoutingInstruction[] routingArray =
      new RoutingInstruction[ routingInstructions.size() ];
    return (RoutingInstruction[]) routingInstructions.toArray( routingArray );
  }

  public void addRoutingInstruction( int sequence, String instruction )
  {
    routingInstructions.add( new RoutingInstruction( sequence, instruction) );
  }

  public void deleteRoutingInstruction( int sequence )
    throws NoSuchRoutingInstruction
  {
    Iterator iter = routingInstructions.iterator();
    while (iter.hasNext())
    {
      RoutingInstruction ri = (RoutingInstruction) iter.next();
      if (ri.sequence == sequence)
      {
        iter.remove();
        return;
      }
    }
    throw new NoSuchRoutingInstruction();
  }

  public void replaceRoutingInstructions(
    RoutingInstruction[] newRoutingInstructions )
  {
    routingInstructions.clear();
    routingInstructions.addAll(
      Arrays.asList( newRoutingInstructions ) );
  }

  // framework and life-cycle methods

  public String ejbCreate( String product, String name,
    RoutingInstruction[] routingInstructions )
  {
    this.product = product;
    this.name = name;
    this.routingInstructions = new LinkedList();
    this.routingInstructions.addAll(
      Arrays.asList( routingInstructions ) );
    return null;
  }

  public void ejbPostCreate( String product, String name,
    RoutingInstruction[] routingInstructions )
  {
  }

  public void ejbActivate()
  {
  }

  public void ejbLoad()
  {
  }

  public void ejbPassivate()
  {
  }

  public void ejbRemove()
  {
  }

  public void ejbStore()
  {
  }

  public void setEntityContext(EntityContext ctx)
  {
  }

  public void unsetEntityContext()
  {
  }
} 